<?php
require_once('Contents.inc.php');

final class Contents_attributes extends Contents {

	/**
	 * Execute contents tab 4
	 *
	 */
	public function execute() {
		include '../help/Help.php';
		if ($this->post['add_attribute']) {
			try {
				$this->add_attribute($this->post['new_attribute_name'], $this->post['new_attribute_description']);
				$this->smarty->assign('operation_success', 'Attribute has been added.');
				$this->display_attributes_list();
			} catch(SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				$this->smarty->assign('operation_error', $e->getMessage());
				$this->display_attributes_list();
			}
		} elseif ($ea=$this->post['edit_attribute']) {//$ea is array with only one element in format: $attributes_id => "změnit"
			try {
				if(is_array($ea)) foreach($ea as $attributes_id => $v) {
					$this->display_edit_attribute($attributes_id);
				}
			} catch(SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				die($e->getMessage());
			}
		}
		elseif ($ea=$this->post['display_publications']) {
			try {
				if(is_array($ea)) foreach($ea as $attributes_id => $v) {

					$this->display_publications($attributes_id);
				}
			} catch(SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				die($e->getMessage());
			}
		}
		elseif ($ea=$this->post['overview']) {
			try {
				if(is_array($ea)) foreach($ea as $publication_id => $v) {
					$this->display_overview($publication_id);
				}
			} catch(SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				die($e->getMessage());
			}
		}
		elseif ($this->post['delete_files'] && $this->get['pid']){
			try {
				$this->delete_files($this->get['pid']);
				$this->smarty->assign('operation_success', 'Files has been deleted.');
				$this->display_overview($this->get['pid']);
			} catch(SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				$this->smarty->assign('operation_error', $e->getMessage());
				$this->display_overview($this->get['pid']);
			}
		} elseif ($this->post['add_file'] && $this->get['pid']) {
			try {
				$this->add_file($this->get['pid']);
				$this->smarty->assign('operation_success', 'File has been added.');
				$this->display_overview($this->get['pid']);
			} catch(SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				$this->smarty->assign('operation_error', $e->getMessage());
				$this->display_overview($this->get['pid']);
			}
		}
		 elseif ($this->post['save_edited_attribute']) {
			try {
				$this->save_attribute($this->post['attributes_id'], $this->post['name'], $this->post['description']);
				$this->smarty->assign('operation_success', 'Changes have been saved.');
				//$this->smarty->assign('refresh', '1 ; URL=index.php');
				$this->display_attributes_list();
				//$this->smarty->display('contents_attributes.tpl');
			} catch(SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				$this->smarty->assign('operation_error', $e->getMessage());
				$this->display_edit_attribute($this->post['attributes_id']);
			}
		} elseif ($da=$this->post['delete_attribute']) {//$da is array with only one element in format: ? => $attributes_id
			try {
				if(is_array($da)) foreach($da as $attributes_id => $v) {
					$this->delete_attribute($attributes_id);
					$this->smarty->assign('operation_success', 'Attribute has been deleted.');
					$this->display_attributes_list();
				}
			} catch(SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				$this->smarty->assign('operation_error', $e->getMessage());

			}
		} elseif ($this->post['save_attributes_scope']) {
			try {
				$this->save_scope($this->post['propagated_attributes']);
				$this->smarty->assign('operation_success', "Visibility of attributes has been saved.");
				$this->display_attributes_list();
			} catch(SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				$this->smarty->assign('operation_error', $e->getMessage());

			}
		} else {
			$this->display_attributes_list();
		}
	}

	/**
	 * Show list of all attributes
	 *
	 */
	private function display_attributes_list() {
		switch($this->get['order']) {
			case(1): $order_by = "ORDER BY confirmed"; break;
			case(2): $order_by = "ORDER BY name"; break;
			case(3): $order_by = "ORDER BY description"; break;
			default: $order_by = "";
		}
		$sql = "SELECT DISTINCT id, name, description, confirmed
				FROM `attributes` ".$order_by;
		$sql_sec = "
				SELECT attributes_id
				FROM `attrib_storage`
				GROUP BY attributes_id
				HAVING COUNT(attributes_id) > 0";
		$attributes = $this->db->getAll($sql, array(), DB_FETCHMODE_ASSOC);
		$warning = $this->db->getAll($sql_sec, array(), DB_FETCHMODE_ORDERED);
		if (is_array($attributes)) foreach ($attributes as $i => $v) { //assign warnings
			if (in_array(array(0 => $v['id']), $warning))
				$attributes[$i]['warning'] = 1;
		}
		$this->smarty->assign('show_attributes', 1);
		$this->smarty->assign('attributes', $attributes);
		$this->smarty->display('contents_attributes.tpl');
	}

	/**
	 * Display edit form of tha attribute
	 *
	 * @param int $attributes_id
	 */
	private function display_edit_attribute($attributes_id) {
		$sql = "SELECT DISTINCT id, name, description
				FROM `attributes`
				WHERE id='$attributes_id'";
		$data =& $this->db->getRow($sql, array(), DB_FETCHMODE_ASSOC);
		if (PEAR::isError($data)) {
    		throw new SAException($data->getMessage());
		}
		$this->smarty->assign('edit_attribute', 1); //determine which part of template to use
		$this->smarty->assign('attributes_id', $attributes_id);
		$this->smarty->assign('name', $data['name']);
		$this->smarty->assign('description', $data['description']);
		$this->smarty->display('contents_attributes.tpl');
	}

	/**
	 * Update name and description of any attribute identified by id
	 *
	 * @param int $attributes_id
	 * @param string $new_name
	 * @param string $new_description
	 */
	private function save_attribute($attributes_id, $new_name, $new_description) {
		if (!ereg('^_([0-9]|[a-zA-Z]){0,31}$', $new_name))
			throw new Exception('First character must be "_", name may contain letters of alphabet and numbers, max. length is 32 chars.');
		if (strlen($new_description) > 255)
			throw new Exception('Attribute description is too long.');
		if ($this->db->getOne("SELECT id FROM `attributes` WHERE name='$new_name' AND id<>'$attributes_id'"))
			throw new Exception('Attribute '.$new_name.' already exists.');
		$res =& $this->db->query("UPDATE `attributes` SET name='$new_name', description='$new_description' WHERE id='$attributes_id'");
		if (PEAR::isError($res)) {
    		throw new SAException($res->getMessage());
		}
	}

	/**
	 * Delete attribute
	 *
	 * @param int $attributes_id
	 */
	private function delete_attribute($attributes_id) {
		$this->db->autoCommit(false);
		/* Uncomment this code only if you are not using DELETE CASCADE refference definition
		$res =& $this->db->query("DELETE FROM `attrib_storage` WHERE attributes_id='$attributes_id'");
		if(PEAR::isError($res)) {
			$this->db->rollBack();
			throw new SAException($res->getMessage);
		}*/
		$res =& $this->db->query("DELETE FROM `attributes` WHERE id='$attributes_id'");
		if(PEAR::isError($res)) {
			$this->db->rollBack();
			throw new SAException($res->getMessage);
		}
		$this->db->commit();
	}

	/**
	 * update `attributes` - take all u
	 *
	 * @param array $propagated_attributes  desired public attributes
	 * in format ? => $attributes_id (eg [0] => 1, [1] => 3)
	 */
	private function save_scope($propagated_attributes) {
		//update `attributes` - take all unconfirmed attributes dependnt to the current
		//publication and if there are some, compare their ids to the $propagated_attributes
		$unconfirmed_attributes = $this->db->getAll("SELECT DISTINCT id FROM `attributes` WHERE confirmed=0", array(), DB_FETCHMODE_ORDERED);
		$confirmed_attributes = $this->db->getAll("SELECT DISTINCT id FROM `attributes` WHERE confirmed=1", array(), DB_FETCHMODE_ORDERED);
		$this->db->autoCommit(false);
		//by desire set private attributes as public
		if (is_array($unconfirmed_attributes)) foreach ($unconfirmed_attributes as $id) {
			$id = $id[0];
			if (in_array($id, $propagated_attributes)) {//decide whether administrator wants this attribute to be public or not
				$res =& $this->db->query("UPDATE `attributes` SET confirmed=1 WHERE id='$id' AND confirmed=0");
				if (PEAR::isError($res)) {
					$this->db->rollback();
		    		throw new SAException($res->getMessage());
				}
			}
		}
		//by desire set public attributes as private
		if (is_array($confirmed_attributes)) foreach ($confirmed_attributes as $id) {
			$id = $id[0];
			if (!in_array($id, $propagated_attributes)) {//decide whether administrator wants this attribute to be public or not
				$res =& $this->db->query("UPDATE `attributes` SET confirmed=0 WHERE id='$id' AND confirmed=1");
				if (PEAR::isError($res)) {
					$this->db->rollback();
		    		throw new SAException($res->getMessage());
				}
			}
		}
		$this->db->commit();
	}

	/**
	 * Add new attribute into the database
	 *
	 * @param string $name
	 * @param string $description
	 */
	private function add_attribute($name, $description)
	{
		if (!ereg('^_([0-9]|[a-zA-Z]){0,31}$', $name))
			throw new Exception('First character must be "_", name may contain letters of alphabet and numbers, max. length is 32 chars.');
		if (strlen($description) > 255)
			throw new Exception('Attribute description is too long.');
		if ($this->db->getOne("SELECT id FROM `attributes` WHERE name='$name'"))
			throw new Exception('Attribute '.$name.' already exists.');
		$submitter_id = $this->auth_module->get_id();
		$sql = "INSERT INTO `attributes` VALUES ('', '$submitter_id', '$name', '$description', 1)";
		$res =& $this->db->query($sql);
		if (PEAR::isError($res))
			throw new SAException($res->getMessage());
	}

	/**
	 * Display choose form of publications
	 *
	 * 
	 */
	private function display_publications($attributes_id) {

		$sql = "SELECT id, title, submitter_id, pub_type
				FROM `publication`
				WHERE id IN
				(SELECT publication_id from attrib_storage where attributes_id = $attributes_id) order by title";

		$publications = $this->db->getAll($sql, array(), DB_FETCHMODE_ASSOC);

		$this->smarty->assign('display_publications', 1);
		$this->smarty->assign('publications', $publications);
		$this->smarty->display('contents_attributes.tpl');

	}

	public function display_overview($publication_id)
	{
		$data = get_all_publication_data($this->db, $publication_id);
		$date_arr = explode('-', $data['issue_date']);
		foreach ($data as $i => $v)
		{
			$this->smarty->assign($i, $v);
		}

		//attributes
		$sql = "SELECT DISTINCT id, name, description, confirmed
				FROM `attrib_storage` JOIN `attributes`
				ON attrib_storage.attributes_id=attributes.id
				WHERE attrib_storage.publication_id = '$publication_id'";
		$attributes = $this->db->getAll($sql, array(), DB_FETCHMODE_ASSOC);
		if (PEAR::isError($attributes)) {
			throw new Exception($attributes->getMessage());
		}
		$s = '';
		if (is_array($attributes))
		foreach ($attributes as $arr)
		{
			$s .=
			'<tr>
				<td><input type="checkbox" name="propagated_attributes[]" value="'.$arr['id'].'" '.($arr['confirmed']?'checked="checked" disabled="disabled"':'').' /></td>
				<td><strong>'.$arr['name'].'</strong></td>'.'
				<td>'.htmlspecialchars($arr['description']).'</td>'.'
				<td>'.htmlspecialchars($this->db->getOne("SELECT value FROM `attrib_storage` WHERE attributes_id='".$arr['id']."' AND publication_id='$publication_id'")).'</td>
			</tr>';
		}
		$this->smarty->assign('attributes', $s);

		$user_name = $this->db->getOne("SELECT name FROM `submitter` WHERE id=?", $data['submitter_id']);
		$user_surname = $this->db->getOne("SELECT surname FROM `submitter` WHERE id=?", $data['submitter_id']);
		if (PEAR::isError($user_name))
			throw new SAException($user_name->getMessage());
		if (PEAR::isError($user_surname))
			throw new SAException($user_surname->getMessage());
		$this->smarty->assign('user_name', $user_name);
		$this->smarty->assign('user_surname', $user_surname);

		//issue_date
		$issue_date_a = $this->db->getOne("SELECT issue_date FROM `publication` WHERE id=$publication_id");
		$issue_date_a=substr($issue_date_a,0, 7);
		$this->smarty->assign('issue_date_a', $issue_date_a);


		$publisher=$data['publisher_id'];
		$publisher_address = $this->db->getOne("SELECT address FROM `publisher` WHERE id=?", $data['publisher_id']);
		$this->smarty->assign('publisher_address', $publisher_address);


		$conference_year_id=$data['conference_year_id'];	
		$journal_id=$data['journal_id'];	

		$authors = get_authors($this->db, $publication_id);
		$categories = get_categories($this->db, $publication_id);
		$conference_year= get_conference_year_data($this->db, $conference_year_id);
		$conference2= get_conference2_data($this->db, $conference_year_id);
		$journal= get_journal_data($this->db, $journal_id);


		$this->smarty->assign('short_look', 1); //determine which part of template to use
		$this->smarty->assign('pid', $publication_id);
		$this->smarty->assign('title', $data['title']);
		$this->smarty->assign('booktitle', $data['booktitle']);
		$this->smarty->assign('pages', $data['pages']);
		$this->smarty->assign('pub_type', $data['pub_type']);
		$this->smarty->assign('isbn', $data['isbn']);

		$dp = new DocumentProvider($this->db, true);
		$files = $dp->get_file_links($publication_id);
		$this->smarty->assign('attached_files', $files);

		$this->smarty->assign('authors', $authors);
		$this->smarty->assign('categories', $categories);
		$this->smarty->assign('conference_year', $conference_year['conference_year']);
		$this->smarty->assign('conference2', $conference2['conference2']);
		$this->smarty->assign('journal', $journal['journal']);
		$this->smarty->assign('issn', $journal['issn']);
		$this->smarty->assign('tab', 4);

		$submitter_id=$this->auth_module->get_id();
		$publ_count = $this->db->getOne("SELECT COUNT(*) FROM `submitter_has_publication` WHERE publication_id=$publication_id AND submitter_id!=$submitter_id");
		$this->smarty->assign('publ_count', $publ_count);


		$this->smarty->display('contents_attributes.tpl');

	}

	/**
	 * Delete files formerly attached to the publication from its storage location
	 *
	 * @param int $pid
	 */
	public function delete_files($publication_id)
	{
		$dirpath = "../storage/$publication_id/";
		$handle = @opendir($dirpath);
		if (!$handle)
			return;
		while ($file = readdir($handle))
		{
			if (is_file($path="../storage/$publication_id/".$file))
				unlink($path);
		}
		closedir($handle);
		$res = $this->db->query("DELETE FROM `documents` WHERE publication_id=?", $publication_id);
		if (PEAR::isError($res))
			throw new SAException($res->getMessage());
    	if (!rmdir($dirpath))
    		throw new SAException("Directory couldn't be deleted.");
	}

	/**
	 * Add document to the publication
	 *
	 * @param int  $publication_id
	 * @param string $title publication title
	 */
	public function add_file($publication_id)
	{

		$file =& $_FILES['file']['tmp_name'];
		$name =& $_FILES['file']['name'];
		$extension = substr($name, strrpos($name, ".") + 1);
		if ((!is_uploaded_file($file) && $file))
			throw new SAException("Not an uploaded file!");
		if ($file) {
			$convertor = new Convertor($this->db, $publication_id);
			if(!file_exists("../storage/$publication_id"))
				mkdir("../storage/$publication_id");
			$res = move_uploaded_file($file, "../storage/$publication_id/".$name);
			$convertor->add_file($name);
			if (!$res) {
				throw new SAException("Can't move uploaded file.");
			}
			$convertor->finish();
		}
	}


}
?>