<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="cs" lang="cs">
<head>
	<meta http-equiv="content-type" content="text/html; charset=utf-8" />
	{if $refresh}<meta http-equiv="refresh" content="{$refresh}" />{/if}
	<title>Database of publications - import publication</title>
	<link rel="stylesheet" type="text/css" href="import.css" />
	<link rel="stylesheet" type="text/css" href="../common/header.css" />
	<script src="../help/help.js" type="text/javascript"></script>
	{literal}
	<script type="text/javascript">
	//<![CDATA[
		function validate()
		{
			bibtex = document.getElementById('bibtex');
			if(!bibtex.value)
			{
				alert('BibTeX definition is missing.');
				title.focus();
				return false;
			}
			return true;
		}

		function addInput()
		{
			var ni = document.getElementById('files');
			var numi = document.getElementById('base_inp');
			var newInput = document.createElement('input');
			newInput.setAttribute("type", "file");
			newInput.setAttribute("name", numi.name);
			var newBr = document.createElement('br');
			ni.appendChild(newInput);
			ni.appendChild(newBr);
		}
	//]]>
	</script>
	{/literal}
	{literal}
		<script src="http://vlsi.felk.cvut.cz/Publikace-test/contents/modify_publication.js" type="text/javascript"></script>
	{/literal}
</head>
<body onload="init_ajax();">
	{include file="header.tpl"}
	{include file="header2.tpl"}

	<div id="mainpanel">
	<div id="content">
	<div id="mainpanel-inside">
		<br />
		{if $operation_error}
			<span class="error">{$operation_error}</span><br/>
		{elseif $operation_success}
			<span class="success">{$operation_success}</span><br/>
		{/if}
		<form action="index.php" method="post" enctype="multipart/form-data" accept-charset="UTF-8">
		{if $stage == '0'}
			Links to <a href="http://portal.acm.org/">ACM</a>, <a href="http://citeseerx.ist.psu.edu/">CiteSeerx</a>, <a href="http://ieeexplore.ieee.org/">IEEEXPLORE</a> <br><br>
			Insert BibTeX definition:
			<center><a id="hide_14" style="display:none" href="javascript:hidediv(14)"><img src="../graphics/b_help.png" alt="help"/></a> </center>
			<center><a id="show_14" href="javascript:showdiv(14,'{$14_help}')"><img src="../graphics/b_help.png" alt="help"/></a> </center>
			<center><div id="hideShow_14" style= "visibility:hidden" class="help_class_left"></div></center>
			<br />
			<textarea name="bibtex" rows="20" cols="80">{$bibtex}</textarea>
			<br /><br /><br />
			Place the publication into a category:
			<br />
			<fieldset style="width:640px">
			<legend>Categories</legend>
			{if $added_categories}
				<strong>Added categories in which the publication will be placed:</strong>
				<span style="color: blue;">
				{foreach from=$added_categories item=current}
					{$current}
				{/foreach}
				</span>
				<input type="submit" name="delete_added_categories" value="smazat" />
				<br /><br />
			{/if}
			{html_checkboxes name="propagated_categories" options=$categories
			selected=$selected_categories separator="<br />"}
			<br /><br />
			<input type="text" name="category_name" value="" /><input type="submit" name="add_category" value="add category" />
			<a id="hide_2" style="display:none" href="javascript:hidediv(2)"><img src="../graphics/b_help.png" alt="help"/></a>
			<a id="show_2" href="javascript:showdiv(2,'{$2_help}')"><img src="../graphics/b_help.png" alt="help"/></a><br /><br />
			<center><div id="hideShow_2" style= "visibility:hidden" class="help_class"></div></center>
			<br />
			</fieldset>
			<br /><br />
			<hr />
			<div class="right"><input type="submit" name="submit_import" onclick="return validate();" value="next &gt;&gt;" /></div>
		{elseif $stage eq 1}
			{if $warning}
				<span class="warning"><img src="../graphics/warn.png" alt="warning" /> {$warning}</span><br/><br/>
			{/if}
			{if $report}
				<div class="report">
					BibTeX definition you are inserting has particular defects, which you may ignore
					and finish import. Regarding to BibTeX rules
					we recommend go back to the previous form
					and correct these defects: <br /><br />
					<span style="color: #FF8C00">{$report}</span>
				</div>
						
			{/if}
			<strong>Type of publication:</strong> {$pub_type}<br />
			<strong>Title:</strong> {$title}<br />
			{if $booktitle}<strong>Booktitle:</strong> {$booktitle}<br />{/if}
			{if $author}<strong>Authors:</strong> {$author}<br />{/if}
			{if $volume}<strong>Volume:</strong> {$volume}<br />{/if}
			{if $number}<strong>Number:</strong> {$number}<br />{/if}
			{if $chapter}<strong>Chapter:</strong> {$chapter}<br />{/if}
			{if $pages}<strong>Pages:</strong> {$pages}<br />{/if}
			{if $series}<strong>Series:</strong> {$series}<br />{/if}
			{if $edition}<strong>Edition:</strong> {$edition}<br />{/if}
			{if $howpublished}<strong>Howpublished:</strong> {$howpublished}<br />{/if}
			{if $type}<strong>Type of report:</strong> {$type}<br />{/if}
			{if $institution}<strong>Institution:</strong> {$institution}<br />{/if}
			{if $school}<strong>School:</strong> {$school}<br />{/if}
			{if $organization}<strong>Organization:</strong> {$organization}<br />{/if}

			{if $journal}<strong>Journal:</strong> {$journal}<br />{/if}

			{if $conference}<strong>Conference:</strong> {$conference}<br />{/if}
			{if $year}<strong>Year: </strong>{$year}<br />{/if}
			{if $month}<strong>Month: </strong>{$month}<br />{/if}
			{if $location}<strong>Location: </strong> {$location}<br />{/if}

			{if $publisher}<strong>Publisher:</strong> {$publisher}<br />{/if}
			{if $address}<strong>Address of publisher:</strong> {$address}<br />{/if}

			{if $isbn}<strong>ISBN:</strong> {$isbn}<br />{/if}
			{if $issn}<strong>ISSN:</strong> {$issn}<br />{/if}
			{if $note}<strong>Note:</strong> {$note}<br />{/if}
			{if $url}<strong>URL:</strong> {$url}<br />{/if}
			{if $editor}<strong>Editor: </strong>{$editor}<br />{/if}
			{if $abstract}<strong>Abstract:</strong><br /> {$abstract}<br /><br />{/if} 
			

			{if $categories or $tmp_cat}
				<strong>Categories:</strong>
				{foreach from=$categories item=current}{$current} {/foreach}
				{foreach from=$tmp_cat item=current}{$current} {/foreach}
				<br />
			{/if}
			
			<center><a id="hide_15" style="display:none" href="javascript:hidediv(15)"><img src="../graphics/b_help.png" alt="help"/></a></center>
			<center><a id="show_15" href="javascript:showdiv(15,'{$15_help}')"><img src="../graphics/b_help.png" alt="help"/></a></center>
			<center><div id="hideShow_15" style="visibility:hidden" class="help_class"></div></center>
			<hr />

			{if $pub_type neq 'proceedings'}
				{if $author}Authors: <strong>{$author}</strong><br />{/if}

				<div class="recommendation ">Choose "Authors!"</div><br />

					<tr id="author">
						<td>
							Authors:
						</td>
						<td>
							<table border="0" cellspacing="0" cellpadding="0" summary="authors">
					<tr>
						<td>
							<table border="0" cellpadding="0" cellspacing="0" summary="add_author">
							<tr>
								<td>name</td>
								<td>middle.</td>
								<td>surname</td>
								<td>&nbsp;</td>
							</tr>

							<tr>
								<td><input type="text" name="author_name" id="author_name" size="12" value="" /></td>
								<td><input type="text" name="author_middle_name" id="author_middle_name" size="12" value="" /></td>
								<td><input type="text" name="author_surname" id="author_surname" size="12" value="" /></td>
								<td><input type="submit" name="add_author" value="add author" /></td>
							</tr>
							</table>
						</td>
						<td>
							&nbsp;
						</td>
						<td style="vertical-align: bottom;">
							<input type="submit" name="up" value="move up" />
							<input type="submit" name="down" value="move down" />
						</td>
					</tr>
					<tr>
						<td>
							<select style="width:390px;" multiple="multiple" name="authors[]" id="authors" size="10">
							{html_options options=$authors }
							</select>
							<br />
							<!--
								<input type="submit" onclick="return (confirm('Are you sure you want to delete this author?')) ? true : false;" name="delete_author" value="delete chosen authors" />
							-->			
	
						</td>
						<td>
							<input type="submit" name="select_author" value="&gt;&gt;" />
							<br />
							<input type="submit" name="deselect_author" value="&lt;&lt;" />
						</td>
						<td>
							<select style="width:390px;" multiple="multiple" name="selected_authors[]" id="selected_authors" size="10" title="chosen authors">
							{html_options values=$selected_authors output=$selected_authors_names}
							</select>
						</td>
					</tr>
					</table>
						</td>
					</tr>
					{/if}


			{if $pub_type == 'article'}
				{if $journal}Journal is: <strong>{$journal}</strong><br />{/if}
				{if $issn}ISSN is: <strong>{$issn}</strong><br />{/if}
				<div class="recommendation ">Choose "Journal!"</div><br />


				<tr id="journal">
						<td>
							Journal:
						</td>
						<td>
						<center>
						<fieldset class="detail_panel">
							<div id="journal_label">
							</div>
							<div class="left">
							<label	>Name*: <input id="journal_name" size="70" type="text" name="journal_name" value="{$journal_name}" {if $journal_name} readonly="readonly" {/if} /></label><br />
							<label>ISSN: <input id="journal_issn" size="20" type="text" name="journal_issn" value="{$journal_issn}" {if $journal_issn} readonly="readonly" {/if} /></label>
							</div>
							<div class="right">
								<input id="add_journal" {if $selected_journal} style="display: none;" {/if} type="submit" name="add_journal" value="add journal"/>
								<input id="reset_journal" {if !$selected_journal} style="display: none;" {/if} type="button" onclick="disable_journal_edit();unset_memo('journal_sel');" name="reset_journal"  value="clear journal" />
								<input id="update_journal" {if !$selected_journal} style="display: none;" {/if} type="submit" name="update_journal" value="update journal" onclick="confirm('Opravdu?')"/>
							</div>
							<br />
							<select name="journal" id="journal_sel" size="10">
							{html_options options=$journals selected=$selected_journal}
							</select>

							<center><a id="hide_4" style="display:none" href="javascript:hidediv(4)"><img src="../graphics/b_help.png" alt="help"/></a> </center>
							<center><a id="show_4" href="javascript:showdiv(4,'{$4_help}')"><img src="../graphics/b_help.png" alt="help"/></a> </center>
							<center><div id="hideShow_4" style= "visibility:hidden" class="help_class"></div></center>
						</fieldset>
						</center>
						</td>
					</tr>
			{/if}

			{if $pub_type eq 'book' or $pub_type eq 'inbook' or $pub_type eq 'incollection' or $pub_type eq 'inproceedings' or $pub_type eq 'proceedings'}
				{if $publisher}Publisher is: <strong>{$publisher}</strong><br />{/if}
				{if $address}Address is: <strong>{$address}</strong><br />{/if}
				<div class="recommendation ">Choose "Publisher!"</div><br />

					<tr id="publisher">
						<td>
							Publisher:
						</td>
						<td>
						<center>
						<fieldset class="detail_panel">
							<div id="publisher_label">
							</div>
							<div class="left">
							<label>Name*: <input id="publisher_name" size="70" type="text" name="publisher_name" value="{$publisher_name}" {if $selected_publisher_c} value="{$selected_publisher_c}" {/if} {if $publisher_name} readonly="readonly" {/if} /></label><br />
							<label>Address: <input id="publisher_address" size="70" type="text" name="publisher_address" value="{$publisher_address}" {if $publisher_address} readonly="readonly" {/if} /></label>
							<div class="right">
								<input id="add_publisher" type="submit" {if $selected_publisher} style="display: none;" {/if}  name="add_publisher" value="add publisher" />
								<input id="reset_publisher" type="button" {if !$selected_publisher} style="display: none;" {/if} onclick="disable_publisher_edit();unset_memo('publisher_sel');" name="reset_publisher"  value="clear publisher" />
								<input id="update_publisher" type="submit" {if !$selected_publisher} style="display: none;" {/if} name="update_publisher" value="update publisher" />
							</div>
							<br />
							

							<select id="publisher_sel" name="publisher" size="10" {if $conference_year} disabled="disabled" {/if} {if $publisher_sel_c} selected=$publisher_sel_c {/if}>
							{html_options options=$publishers selected=$selected_publisher }
							</select>

							<center><a id="hide_7" style="display:none" href="javascript:hidediv(7)"><img src="../graphics/b_help.png" alt="help"/></a> </center>
							<center><a id="show_7" href="javascript:showdiv(7,'{$7_help}')"><img src="../graphics/b_help.png" alt="help"/></a> </center>
							<center><div id="hideShow_7" style= "visibility:hidden" class="help_class"></div></center>
							</div>
						</fieldset>
						</center>
						</td>
					</tr>
					{/if}



			
			{if $pub_type == 'inproceedings' || $pub_type == 'proceedings'}
			Title is: <strong>{$title}</strong><br />
			{if $booktitle}Booktitle is: <strong>{$booktitle}</strong><br />{/if}
			{if $publisher}Publisher is: <strong>{$publisher}</strong><br />{/if}
			{if $year}Year: <strong>{$year} </strong><br />{/if}
			{if $isbn}ISBN: <strong>{$isbn} </strong><br />{/if}
			<div class="recommendation ">Choose "Conference" and "Year of Conference!" </div><br />
			
			<br />
			<tr>
			   <td>
				<center>
				<fieldset class="detail_panel">
					<div id="conference_label">
					</div>
						Conference:<br />
						<div class="left">
						<label>Name*: <input id="conference_name2" type="text" size="85" name="conference_name2" value="{$conference_name2}" {if $conference_year && $conference_name2} readonly="readonly" {/if}  /></label><br />
						<label>Abbreviation: <input id="conference_abbreviation2" type="text" size="20" name="conference_abbreviation2" value="{$conference_abbreviation2}" {if $conference_year && $conference_abbreviation2} readonly="readonly" {/if} /></label>
						<label>First year: <input id="conference_first_year2" type="text" size="10" name="conference_first_year2" value="{$conference_first_year2}" {if $conference_year && $conference_first_year2<>0000} readonly="readonly" {/if} /></label><br />
						<label>Description: <input id="conference_description2" type="text" size="80" name="conference_description2" value="{$conference_description2}" {if $conference_year && $conference_description2} readonly="readonly" {/if} /></label>						

						<div class="right">
								<input id="add_conference2" {if $selected_conference2} style="display: none;" {/if} type="submit" name="add_conference2" value="add conference" />
								<input id="reset_conference2" {if !$selected_conference2} style="display: none;" {/if} type="button" name="reset_conference2" onclick="disable_conference2_edit(); unset_memo_conference2('conference_year_sel');"   value="clear conference" />
								<input id="update_conference2" {if !$selected_conference2} style="display: none;" {/if} type="submit" name="update_conference2" value="update conference" />
						</div>
						<br />
						{literal}	
							<script type="text/javascript">
								forbidden_conferences = {$forbidden_conferences};
							</script>
						{/literal}

						<select name="conference2" onchange="get_options(this.value);" id="conference_sel2" size="10" value="{$conference2_sel}" >
							{html_options options=$conference2 selected=$selected_conference2}
						</select>

						<center><a id="hide_5" style="display:none" href="javascript:hidediv(5)"><img src="../graphics/b_help.png" alt="help"/></a> </center>
						<center><a id="show_5" href="javascript:showdiv(5,'{$5_help}')"><img src="../graphics/b_help.png" alt="help"/></a> </center>
						<center><div id="hideShow_5" style= "visibility:hidden" class="help_class"></div></center>	
						<br />

						Year of conference:<br />
						<label>Name*: <input id="conference_year_name" type="text" size="85" name="conference_year_name" value="{$conference_year_name}" {if $selected_conference_year} readonly="readonly" {/if} /></label><br />
						<label>Year: <input id="conference_year_year" type="text" size="10" name="conference_year_year" value="{$conference_year_year}" {if $selected_conference_year && $conference_year_year && $conference_year_year<>0000} readonly="readonly" {/if} /></label>
						<label>From: <input id="conference_year_from" type="text" size="10" name="conference_year_from" value="{$conference_year_from}" {if $selected_conference_year && $conference_year_from && $conference_year_from<>0000-00-00} readonly="readonly" {/if} /></label>
						<label>To: <input id="conference_year_to" type="text" size="10" name="conference_year_to" value="{$conference_year_to}" {if $selected_conference_year && $conference_year_to && $conference_year_to<>0000-00-00} readonly="readonly" {/if} /></label><br />
						<label>Location: <input id="conference_year_location" type="text" size="83" name="conference_year_location" value="{$conference_year_location}"  {if $selected_conference_year && $conference_year_location} readonly="readonly" {/if} /></label><br />
						<label>ISBN: <input id="conference_year_isbn" type="text" name="conference_year_isbn" size="20" value="{$conference_year_isbn}" {if $selected_conference_year && $conference_year_isbn} readonly="readonly" {/if} /></label><br />
						<label>Description: <input id="conference_year_description" type="text" size="80" name="conference_year_description" value="{$conference_year_description}" {if $selected_conference_year && $conference_year_description} readonly="readonly" {/if} /></label><br />
						<label>Publisher:</label>
						<select id="publisher_sel_c" name="publisher_c" size="1" style="width: 400px" {if $selected_publisher_c} disabled="disabled" {/if}>
							<option>Select publisher</option>
							{html_options options=$publisher_c selected=$selected_publisher_c}
						</select>
						<input id="publ" type="hidden" name="publisher_sel_c" value="{$publisher_sel_c}" />
						<input type="button" onclick="unset_memo('publisher_sel_c');" value="unset publisher" />


						<div class="right">
								<input id="add_conference_year_c" {if $selected_conference_year} style="display: none;" {/if} type="submit" name="add_conference_year_c" value="add conference year" />
								<input id="reset_conference_year" {if !$selected_conference_year} style="display: none;" {/if} type="button" name="reset_conference_year" onclick="unset_memo_conference_year('conference_year_sel');disable_conference_year_edit();"   value="clear conference year" />
								<input id="update_conference_year_c" {if !$selected_conference_year} style="display: none;" {/if} type="submit" name="update_conference_year_c" value="update conference year" />
						</div>

						<select name="conference_year" onchange="get_options(this.value);" id="conference_year_sel" size="10" value="{$conference_year_sel}" >
							{html_options options=$conference_year selected=$selected_conference_year}
						</select>

						<center><a id="hide_6" style="display:none" href="javascript:hidediv(6)"><img src="../graphics/b_help.png" alt="help"/></a> </center>
						<center><a id="show_6" href="javascript:showdiv(6,'{$6_help}')"><img src="../graphics/b_help.png" alt="help"/></a> </center>
						<center><div id="hideShow_6" style= "visibility:hidden" class="help_class"></div></center>
						</div>
				</fieldset> 
				</center>
			</td>
		   </tr>

		{/if}


			<br /><br />
			You can add files to the imported publicaton {if $permitted_extensions}({$permitted_extensions}){/if}:<br />
			<div id="files">
				<input type="button" name="text_addfile" value="add another one file" onclick="addInput();"><br />
				<input id="base_inp" type="file" name="documents[]"/>
				<a id="hide_18" style="display:none" href="javascript:hidediv(18)"><img src="../graphics/b_help.png" alt="help"/></a>
				<a id="show_18" href="javascript:showdiv(18,'{$18_help}')"><img src="../graphics/b_help.png" alt="help"/></a><br /><br />
			</div>
				
			<center><div id="hideShow_18" style="visibility:hidden" class="help_class_half"></div></center>
			
			<br /><br />
			Set as My publication? <input type="checkbox" checked name="want_set" value="yes">
			<a id="hide_13" style="display:none" href="javascript:hidediv(13)"><img src="../graphics/b_help.png" alt="help"/></a>
			<a id="show_13" href="javascript:showdiv(13,'{$13_help}')"><img src="../graphics/b_help.png" alt="help"/></a>	
			<center><div id="hideShow_13" style="visibility:hidden" class="help_class_half"></div></center>

			<hr />
			<div style="float: left;"><input type="submit" name="previous" value="&lt;&lt; back" /></div>
			<div style="float: right;"><input type="submit" name="submit_finish" value="finish import"  /></div><br />
			
		{/if}
		</form>
	</div>
	</div>
	</div>
</body>
</html>